
//+------------------------------------------------------------------+
//|                                                    TrendStats.mq4|
//|                           Copyright  2006, Done by investor_me. |
//|                                            investor.me@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Done by investor_me."
#property link      "investor.me@gmail.com"

extern int timeframe=1;
extern int EMA=1;


int last_trend,buy_trend,sell_trend, buys, sells,total_sells,total_buys,last_day=-1,last_minute=-1;

double   total_sell_length,total_buy_length,avg_sell_length,max_sell_length,avg_buy_length,max_buy_length; 

double   buy_profit, total_buy_profit,avg_buy_profit, max_buy_profit,
         sell_profit, total_sell_profit,avg_sell_profit, max_sell_profit, last_MA; 

datetime max_sell_time,max_buy_time, max_buy_profit_time, max_sell_profit_time, last_time;

bool reported=false;

int init()  
  { 
   return(0);
  }

int deinit(){ return(0); }

double M(int value, int shift) { return (iMA(Symbol(),0,value,0,MODE_EMA,PRICE_CLOSE,shift)); }

//double M(int value, int shift) { return (iClose(Symbol(),value,shift)); }

void print_stats(int timeframe)
  {
   if (TimeCurrent()-last_time>=60*timeframe) 
    {
     if (last_day==DayOfWeek() && last_trend==1 && M(EMA,0)<last_MA)   
       { 
         last_MA=M(EMA,0); 
         total_buy_length=total_buy_length+total_buys;
         avg_buy_length=total_buy_length/(buys+1); 
         if (total_buys>max_buy_length) { max_buy_length=total_buys; max_buy_time=Time[0]; } 

         buy_profit=buy_profit-(iClose(NULL,0,1)-iClose(NULL,0,0));
         total_buy_profit=total_buy_profit+buy_profit;
         avg_buy_profit=total_buy_profit/(buys+1);
         if (buy_profit>max_buy_profit) { max_buy_profit=buy_profit; max_buy_profit_time=Time[0]; } 

         buys++;
         total_sells=1; 
         total_buys=0;  
         buy_profit=0; sell_profit=0;
         last_trend=2;  
       }  

     else if (last_day==DayOfWeek() && last_trend==2 && M(EMA,0)>last_MA)        
       { 
         last_MA=M(EMA,0);  
         total_sell_length=total_sell_length+total_sells;
         avg_sell_length=total_sell_length/(sells+1); 
         if (total_sells>max_sell_length) { max_sell_length=total_sells; max_sell_time=Time[0]; } 

         sell_profit=sell_profit-(iClose(NULL,0,0)-iClose(NULL,0,1));
         total_sell_profit=total_sell_profit+sell_profit;
         avg_sell_profit=total_sell_profit/(sells+1);
         if (sell_profit>max_sell_profit) { max_sell_profit=sell_profit; max_sell_profit_time=Time[0]; } 

         sells++;
         total_buys=1;
         sell_profit=0; buy_profit=0;
         total_sells=0;  
         last_trend=1;  
       }  

     if (last_day!=DayOfWeek() && last_day>0)
       {
         Print ("==================================");
         Print ("Report for:",TimeToStr(last_time,TIME_DATE)," at:",TimeToStr(last_time,TIME_MINUTES));
         Print ("----------------------");
         Print ("*B Total_buys:",buys," Avg_buy length:",DoubleToStr(avg_buy_length,5)," Max buy length:",DoubleToStr(max_buy_length,5)," at:",TimeToStr(max_buy_time,TIME_SECONDS));
         Print ("   Total buy profit:",DoubleToStr(total_buy_profit/Point,5)," Avg_buy profit:",DoubleToStr(avg_buy_profit/Point,5)," Max buy profit:",DoubleToStr(max_buy_profit/Point,5)," at:",TimeToStr(max_buy_profit_time,TIME_SECONDS));
         Print ("*S Total_sels:",sells," Avg_sels length:",DoubleToStr(avg_sell_length,5)," Max sel length:",DoubleToStr(max_sell_length,5)," at:",TimeToStr(max_sell_time,TIME_SECONDS));
         Print ("   Total sel profit:",DoubleToStr(total_sell_profit/Point,5)," Avg_sel profit:",DoubleToStr(avg_sell_profit/Point,5)," Max sel profit:",DoubleToStr(max_sell_profit/Point,5)," at:",TimeToStr(max_sell_profit_time,TIME_SECONDS));
         sells=0; buys=0; last_trend=0;
         total_sells=0; total_sell_length=0; avg_sell_length=0; max_sell_length=0;
         total_buys=0; total_buy_length=0; avg_buy_length=0; max_buy_length=0;
         sell_profit=0; total_sell_profit=0; avg_sell_profit=0; max_sell_profit=0;
         buy_profit=0; total_buy_profit=0; avg_buy_profit=0;  max_buy_profit=0;
         reported=true; last_day=DayOfWeek();
         last_minute=TimeCurrent(); 
         return(0);
       } 

      last_time=Time[0]; last_day=DayOfWeek();
   
      if (last_day==DayOfWeek() && (last_trend==1 || last_trend==0) && M(EMA,0)>=last_MA) { total_buys++;  if (last_trend==1) buy_profit=buy_profit+(iClose(NULL,0,0)-iClose(NULL,0,1)); last_trend=1; /*Print("buys:",total_buys," price:",DoubleToStr(M(EMA,0),5)," old p:",DoubleToStr(last_MA,5)," at:",TimeToStr(Time[0],TIME_MINUTES)," on:",TimeToStr(Time[0],TIME_DATE)," m:",Minute());*/ last_MA=M(EMA,0); }
      else if (last_day==DayOfWeek() && (last_trend==2 || last_trend==0) && M(EMA,0)<=last_MA) { total_sells++; if (last_trend==2) sell_profit=sell_profit+(iClose(NULL,0,1)-iClose(NULL,0,0)); last_trend=2; /*Print("sells:",total_sells," price:",DoubleToStr(M(EMA,0),5)," old p:",DoubleToStr(last_MA,5)," at:",TimeToStr(Time[0],TIME_MINUTES)," on:",TimeToStr(Time[0],TIME_DATE)," m:",Minute());*/ last_MA=M(EMA,0); }
    }
   last_minute=TimeCurrent(); 
}

int start ()
  {
   print_stats(timeframe);
   return(0);
  }   